local assets =
{
	Asset("ANIM", "anim/healing_cream.zip"),
}

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "idle_water", "idle")
    
    inst.AnimState:SetBank("healing_cream")
    inst.AnimState:SetBuild("healing_cream")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("heal_fertilize")
	
    inst:AddComponent("fertilizer")
    inst.components.fertilizer.fertilizervalue = TUNING.GLOMMERFUEL_FERTILIZE*6
    inst.components.fertilizer.soil_cycles = TUNING.GLOMMERFUEL_SOILCYCLES*4
    inst.components.fertilizer.withered_cycles = 3
    inst.components.fertilizer.planthealing = true
	
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
    
    inst:AddComponent("healer")
    inst.components.healer:SetHealthAmount(TUNING.HEALING_LARGE)
    
    return inst
end

return Prefab( "common/inventory/compostwrap", fn, assets) 

